2014-10-07 15:40:31 +00:00
#!/bin/sh
2012-05-22 22:36:54 +00:00
2014-02-10 15:35:59 +00:00
set -e
2012-05-22 22:36:54 +00:00
2020-09-30 15:48:49 +00:00
umask 0022
2014-02-10 15:35:59 +00:00
dest = "/nix"
self = " $( dirname " $0 " ) "
nix = "@nix@"
2014-12-10 15:05:08 +00:00
cacert = "@cacert@"
2014-02-10 15:35:59 +00:00
2017-01-24 18:59:55 +00:00
2016-12-02 13:18:50 +00:00
if ! [ -e " $self /.reginfo " ] ; then
2014-02-10 15:35:59 +00:00
echo " $0 : incomplete installer (.reginfo is missing) " >& 2
fi
2019-07-25 13:39:44 +00:00
if [ -z " $USER " ] && ! USER = $( id -u -n) ; then
2014-02-10 15:35:59 +00:00
echo " $0 : \$USER is not set " >& 2
exit 1
fi
2017-07-09 17:07:28 +00:00
if [ -z " $HOME " ] ; then
echo " $0 : \$HOME is not set " >& 2
exit 1
fi
2018-12-20 19:05:14 +00:00
# macOS support for 10.12.6 or higher
2017-07-09 17:07:28 +00:00
if [ " $( uname -s) " = "Darwin" ] ; then
2020-11-27 22:42:15 +00:00
IFS = '.' read -r macos_major macos_minor macos_patch << EOF
2020-09-08 04:53:31 +00:00
$( sw_vers -productVersion)
EOF
if [ " $macos_major " -lt 10 ] || { [ " $macos_major " -eq 10 ] && [ " $macos_minor " -lt 12 ] ; } || { [ " $macos_minor " -eq 12 ] && [ " $macos_patch " -lt 6 ] ; } ; then
# patch may not be present; command substitution for simplicity
2018-12-20 19:05:14 +00:00
echo " $0 : macOS $( sw_vers -productVersion) is not supported, upgrade to 10.12.6 or higher "
2017-07-09 17:07:28 +00:00
exit 1
fi
2018-04-19 17:37:54 +00:00
fi
2017-07-09 17:07:28 +00:00
2018-09-01 12:51:32 +00:00
# Determine if we could use the multi-user installer or not
2020-11-27 22:42:15 +00:00
if [ " $( uname -s) " = "Linux" ] ; then
2018-09-01 12:51:32 +00:00
echo "Note: a multi-user installation is possible. See https://nixos.org/nix/manual/#sect-multi-user-installation" >& 2
2018-04-19 17:37:54 +00:00
fi
2020-11-27 22:42:15 +00:00
case " $( uname -s) " in
"Darwin" )
INSTALL_MODE = daemon; ;
*)
INSTALL_MODE = no-daemon; ;
esac
# space-separated string
ACTIONS =
2020-05-12 16:58:13 +00:00
# handle the command line flags
2019-12-15 15:43:43 +00:00
while [ $# -gt 0 ] ; do
case $1 in
--daemon)
2020-11-27 22:42:15 +00:00
INSTALL_MODE = daemon
ACTIONS = " ${ ACTIONS } install "
; ;
2019-12-15 15:43:43 +00:00
--no-daemon)
2020-11-27 22:42:15 +00:00
if [ " $( uname -s) " = "Darwin" ] ; then
printf '\e[1;31mError: --no-daemon installs are no-longer supported on Darwin/macOS!\e[0m\n' >& 2
exit 1
fi
INSTALL_MODE = no-daemon
# intentional tail space
ACTIONS = " ${ ACTIONS } install "
; ;
# --uninstall)
# # intentional tail space
# ACTIONS="${ACTIONS}uninstall "
# ;;
2019-12-15 15:43:43 +00:00
--no-channel-add)
2020-05-26 13:49:26 +00:00
export NIX_INSTALLER_NO_CHANNEL_ADD = 1; ;
2020-02-26 09:50:40 +00:00
--daemon-user-count)
2020-05-26 13:49:26 +00:00
export NIX_USER_COUNT = $2
2020-02-26 09:50:40 +00:00
shift; ;
2019-12-15 15:43:43 +00:00
--no-modify-profile)
NIX_INSTALLER_NO_MODIFY_PROFILE = 1; ;
2020-05-15 02:59:10 +00:00
--darwin-use-unencrypted-nix-store-volume)
2020-11-27 22:42:15 +00:00
{
echo "Warning: the flag --darwin-use-unencrypted-nix-store-volume"
echo " is no longer needed and will be removed in the future."
echo ""
} >& 2; ;
2020-05-25 15:31:46 +00:00
--nix-extra-conf-file)
2020-11-27 22:42:15 +00:00
# shellcheck disable=SC2155
export NIX_EXTRA_CONF = " $( cat " $2 " ) "
2020-05-25 15:31:46 +00:00
shift; ;
2019-12-15 15:43:43 +00:00
*)
2020-11-27 22:42:15 +00:00
{
echo "Nix Installer [--daemon|--no-daemon] [--daemon-user-count INT] [--no-channel-add] [--no-modify-profile] [--nix-extra-conf-file FILE]"
2019-12-15 15:43:43 +00:00
echo "Choose installation method."
echo ""
echo " --daemon: Installs and configures a background daemon that manages the store,"
echo " providing multi-user support and better isolation for local builds."
echo " Both for security and reproducibility, this method is recommended if"
echo " supported on your platform."
echo " See https://nixos.org/nix/manual/#sect-multi-user-installation"
echo ""
echo " --no-daemon: Simple, single-user installation that does not require root and is"
echo " trivial to uninstall."
echo " (default)"
echo ""
echo " --no-channel-add: Don't add any channels. nixpkgs-unstable is installed by default."
echo ""
2021-07-23 17:51:37 +00:00
echo " --no-modify-profile: Don't modify the user profile to automatically load nix."
2019-12-15 15:43:43 +00:00
echo ""
2020-05-26 13:49:26 +00:00
echo " --daemon-user-count: Number of build users to create. Defaults to 32."
echo ""
2021-07-23 17:56:30 +00:00
echo " --nix-extra-conf-file: Path to nix.conf to prepend when installing /etc/nix/nix.conf"
2020-05-26 13:49:26 +00:00
echo ""
2020-11-06 10:53:00 +00:00
if [ -n " ${ INVOKED_FROM_INSTALL_IN :- } " ] ; then
echo " --tarball-url-prefix URL: Base URL to download the Nix tarball from."
fi
2020-11-27 22:42:15 +00:00
} >& 2
2019-12-15 15:43:43 +00:00
exit; ;
esac
2020-05-12 16:58:13 +00:00
shift
done
2018-03-28 13:16:13 +00:00
2018-04-19 17:37:54 +00:00
if [ " $INSTALL_MODE " = "daemon" ] ; then
2020-07-07 20:08:23 +00:00
printf '\e[1;31mSwitching to the Multi-user Installer\e[0m\n'
2020-11-27 22:42:15 +00:00
exec " $self /install-multi-user " $ACTIONS # let ACTIONS split
2017-07-09 17:07:28 +00:00
exit 0
fi
2014-02-10 15:35:59 +00:00
if [ " $( id -u) " -eq 0 ] ; then
2014-11-18 13:49:42 +00:00
printf '\e[1;31mwarning: installing Nix as root is not supported by this script!\e[0m\n'
2014-02-10 15:35:59 +00:00
fi
echo "performing a single-user installation of Nix..." >& 2
if ! [ -e $dest ] ; then
cmd = " mkdir -m 0755 $dest && chown $USER $dest "
2016-05-18 19:02:48 +00:00
echo " directory $dest does not exist; creating it by running ' $cmd ' using sudo " >& 2
2014-02-10 15:35:59 +00:00
if ! sudo sh -c " $cmd " ; then
2017-07-30 11:27:57 +00:00
echo " $0 : please manually run ' $cmd ' as root to create $dest " >& 2
2014-02-10 15:35:59 +00:00
exit 1
fi
fi
if ! [ -w $dest ] ; then
2020-03-11 18:41:22 +00:00
echo " $0 : directory $dest exists, but is not writable by you. This could indicate that another user has already performed a single-user installation of Nix on this system. If you wish to enable multi-user support see https://nixos.org/nix/manual/#ssec-multi-user. If you wish to continue with a single-user install for $USER please run 'chown -R $USER $dest ' as root. " >& 2
2014-02-10 15:35:59 +00:00
exit 1
fi
mkdir -p $dest /store
2016-12-02 13:18:50 +00:00
printf "copying Nix to %s..." " ${ dest } /store " >& 2
2021-01-21 16:30:26 +00:00
# Insert a newline if no progress is shown.
if [ ! -t 0 ] ; then
echo ""
fi
2014-02-10 15:35:59 +00:00
2016-12-02 13:18:50 +00:00
for i in $( cd " $self /store " >/dev/null && echo ./*) ; do
2021-01-21 16:30:26 +00:00
if [ -t 0 ] ; then
printf "." >& 2
fi
2014-02-10 15:35:59 +00:00
i_tmp = " $dest /store/ $i . $$ "
if [ -e " $i_tmp " ] ; then
rm -rf " $i_tmp "
fi
if ! [ -e " $dest /store/ $i " ] ; then
2019-12-22 05:30:38 +00:00
cp -RPp " $self /store/ $i " " $i_tmp "
2014-10-07 15:40:31 +00:00
chmod -R a-w " $i_tmp "
chmod +w " $i_tmp "
2014-02-10 15:35:59 +00:00
mv " $i_tmp " " $dest /store/ $i "
2014-10-07 15:40:31 +00:00
chmod -w " $dest /store/ $i "
2014-02-10 15:35:59 +00:00
fi
done
echo "" >& 2
2016-12-02 13:18:50 +00:00
if ! " $nix /bin/nix-store " --load-db < " $self /.reginfo " ; then
2014-02-10 15:35:59 +00:00
echo " $0 : unable to register valid paths " >& 2
exit 1
fi
2012-05-22 22:36:54 +00:00
2020-11-27 22:42:15 +00:00
# shellcheck source=./nix-profile.sh.in
2016-12-02 13:18:50 +00:00
. " $nix /etc/profile.d/nix.sh "
2014-02-10 15:35:59 +00:00
2016-12-02 13:18:50 +00:00
if ! " $nix /bin/nix-env " -i " $nix " ; then
2014-02-10 15:35:59 +00:00
echo " $0 : unable to install Nix into your default profile " >& 2
2012-05-22 22:36:54 +00:00
exit 1
fi
2014-12-13 15:53:21 +00:00
# Install an SSL certificate bundle.
2016-12-02 13:18:50 +00:00
if [ -z " $NIX_SSL_CERT_FILE " ] || ! [ -f " $NIX_SSL_CERT_FILE " ] ; then
2014-12-13 15:53:21 +00:00
$nix /bin/nix-env -i " $cacert "
2016-10-13 15:09:10 +00:00
export NIX_SSL_CERT_FILE = " $HOME /.nix-profile/etc/ssl/certs/ca-bundle.crt "
2014-12-13 15:53:21 +00:00
fi
2014-02-10 09:50:29 +00:00
# Subscribe the user to the Nixpkgs channel and fetch it.
2020-05-12 10:13:40 +00:00
if [ -z " $NIX_INSTALLER_NO_CHANNEL_ADD " ] ; then
if ! $nix /bin/nix-channel --list | grep -q "^nixpkgs " ; then
$nix /bin/nix-channel --add https://nixos.org/channels/nixpkgs-unstable
fi
if [ -z " $_NIX_INSTALLER_TEST " ] ; then
if ! $nix /bin/nix-channel --update nixpkgs; then
echo "Fetching the nixpkgs channel failed. (Are you offline?)"
echo "To try again later, run \"nix-channel --update nixpkgs\"."
fi
2019-02-13 10:28:28 +00:00
fi
2014-11-18 13:49:42 +00:00
fi
2014-02-10 09:50:29 +00:00
2014-02-10 15:35:59 +00:00
added =
2019-10-19 03:25:18 +00:00
p = $HOME /.nix-profile/etc/profile.d/nix.sh
2016-11-03 17:02:29 +00:00
if [ -z " $NIX_INSTALLER_NO_MODIFY_PROFILE " ] ; then
# Make the shell source nix.sh during login.
for i in .bash_profile .bash_login .profile; do
fn = " $HOME / $i "
if [ -w " $fn " ] ; then
if ! grep -q " $p " " $fn " ; then
echo " modifying $fn ... " >& 2
2020-07-18 15:23:43 +00:00
echo -e " \nif [ -e $p ]; then . $p ; fi # added by Nix installer " >> " $fn "
2016-11-03 17:02:29 +00:00
fi
added = 1
break
2014-02-10 15:35:59 +00:00
fi
2016-11-03 17:02:29 +00:00
done
2019-12-15 20:11:14 +00:00
for i in .zshenv .zshrc; do
fn = " $HOME / $i "
if [ -w " $fn " ] ; then
if ! grep -q " $p " " $fn " ; then
echo " modifying $fn ... " >& 2
2020-07-18 15:23:43 +00:00
echo -e " \nif [ -e $p ]; then . $p ; fi # added by Nix installer " >> " $fn "
2019-12-15 20:11:14 +00:00
fi
added = 1
break
fi
done
2016-11-03 17:02:29 +00:00
fi
2014-02-10 15:35:59 +00:00
if [ -z " $added " ] ; then
cat >& 2 <<EOF
Installation finished! To ensure that the necessary environment
2012-05-22 22:36:54 +00:00
variables are set, please add the line
2014-02-10 15:35:59 +00:00
. $p
2012-05-22 22:36:54 +00:00
to your shell profile ( e.g. ~/.profile) .
EOF
2014-02-10 15:35:59 +00:00
else
cat >& 2 <<EOF
Installation finished! To ensure that the necessary environment
variables are set, either log in again, or type
. $p
in your shell.
EOF
2014-02-10 09:50:29 +00:00
fi